/* An XEmacs module that does absolutely nothing
   Copyright (C) 2002 Jerry James <james@xemacs.org>

   This module is in the public domain. */

/* Author: Jerry James <james@xemacs.org> */

#include <emodules.h>
#include <events.h>

static int hooked_once;    /* Whether the event stream has been hooked */
static int (*orig_event_pending_p) (int);
static void (*orig_next_event_cb) (Lisp_Event *);

DEFUN ("null-function", Fnull_function, 0, 0, 0, /*
This function does absolutely nothing.
*/
       ())
{
  return Qnil;
}

void
syms_of_null (void)
{
  DEFSUBR (Fnull_function);
}

static int null_event_pending_p (int user_p)
{
  return orig_event_pending_p (user_p);
}

static void null_next_event_cb (Lisp_Event *event)
{
  orig_next_event_cb (event);
}

void
vars_of_null (void)
{
  Fprovide (intern ("null"));

  /* Hook the event callbacks, once */
  if (!hooked_once) {
    hooked_once = 1;
    orig_event_pending_p = event_stream->event_pending_p;
    orig_next_event_cb = event_stream->next_event_cb;
    event_stream->event_pending_p = null_event_pending_p;
    event_stream->next_event_cb = null_next_event_cb;
  }
}
